 Documentation/block/00-INDEX          |    2 +
 Documentation/block/io-controller.txt |  378 +++
 block/Kconfig.iosched                 |   82 +-
 block/Makefile                        |    1 +
 block/as-iosched.c                    |  500 +++-
 block/blk-core.c                      |  333 ++-
 block/blk-ioc.c                       |   33 +-
 block/blk-settings.c                  |    1 +
 block/blk-sysfs.c                     |   58 +-
 block/blk.h                           |    4 +
 block/cfq-iosched.c                   | 1297 +++-------
 block/deadline-iosched.c              |  125 +-
 block/elevator-fq.c                   | 4327 +++++++++++++++++++++++++++++++++
 block/elevator-fq.h                   |  771 ++++++
 block/elevator.c                      |  198 ++-
 block/noop-iosched.c                  |   72 +-
 drivers/md/dm-table.c                 |   11 +-
 drivers/md/dm.c                       |    7 +-
 drivers/md/dm.h                       |    3 +-
 drivers/md/linear.c                   |    7 +-
 drivers/md/multipath.c                |    7 +-
 drivers/md/raid0.c                    |    6 +-
 drivers/md/raid1.c                    |    9 +-
 drivers/md/raid10.c                   |    6 +-
 drivers/md/raid5.c                    |    2 +-
 fs/afs/write.c                        |    8 +-
 fs/btrfs/disk-io.c                    |    6 +-
 fs/btrfs/extent_io.c                  |   12 +
 fs/btrfs/volumes.c                    |    8 +-
 fs/buffer.c                           |    2 +
 fs/cifs/file.c                        |   11 +
 fs/direct-io.c                        |    2 +
 fs/ext2/ialloc.c                      |    2 +-
 fs/gfs2/aops.c                        |   12 +
 fs/nilfs2/segbuf.c                    |    3 +-
 fs/xfs/linux-2.6/xfs_aops.c           |    2 +-
 fs/xfs/linux-2.6/xfs_buf.c            |    2 +-
 include/linux/backing-dev.h           |   61 +-
 include/linux/biotrack.h              |  103 +
 include/linux/blkdev.h                |  106 +-
 include/linux/cgroup_subsys.h         |   12 +
 include/linux/elevator.h              |   90 +-
 include/linux/iocontext.h             |   11 +-
 include/linux/memcontrol.h            |    6 +
 include/linux/mmzone.h                |    4 +-
 include/linux/page_cgroup.h           |   31 +-
 init/Kconfig                          |   23 +
 mm/Makefile                           |    4 +-
 mm/backing-dev.c                      |   62 +
 mm/biotrack.c                         |  321 +++
 mm/bounce.c                           |    2 +
 mm/filemap.c                          |    2 +
 mm/memcontrol.c                       |    6 +
 mm/memory.c                           |    5 +
 mm/page-writeback.c                   |   13 +
 mm/page_cgroup.c                      |   17 +-
 mm/readahead.c                        |    2 +-
 mm/swap_state.c                       |    2 +
 58 files changed, 7941 insertions(+), 1252 deletions(-)

diff --git a/Documentation/block/00-INDEX b/Documentation/block/00-INDEX
index 961a051..dc8bf95 100644
--- a/Documentation/block/00-INDEX
+++ b/Documentation/block/00-INDEX
@@ -10,6 +10,8 @@ capability.txt
 	- Generic Block Device Capability (/sys/block/<disk>/capability)
 deadline-iosched.txt
 	- Deadline IO scheduler tunables
+io-controller.txt
+	- IO controller for provding hierarchical IO scheduling
 ioprio.txt
 	- Block io priorities (in CFQ scheduler)
 request.txt
diff --git a/block/Kconfig.iosched b/block/Kconfig.iosched
index 7e803fc..79f188c 100644
--- a/block/Kconfig.iosched
+++ b/block/Kconfig.iosched
@@ -2,6 +2,19 @@ if BLOCK
 
 menu "IO Schedulers"
 
+config ELV_FAIR_QUEUING
+	bool
+	default n
+	---help---
+	  Traditionally only cfq had notion of multiple queues and it did
+	  fair queuing at its own. With the cgroups and need of controlling
+	  IO, now even the simple io schedulers like noop, deadline, as will
+	  have one queue per cgroup and will need hierarchical fair queuing.
+	  Instead of every io scheduler implementing its own fair queuing
+	  logic, this option enables fair queuing in elevator layer so that
+	  other ioschedulers can make use of it.
+	  If unsure, say N.
+
 config IOSCHED_NOOP
 	bool
 	default y
@@ -12,6 +25,17 @@ config IOSCHED_NOOP
 	  that do their own scheduling and require only minimal assistance from
 	  the kernel.
 
+config IOSCHED_NOOP_HIER
+	bool "Noop Hierarchical Scheduling support"
+	depends on IOSCHED_NOOP && CGROUPS
+	select ELV_FAIR_QUEUING
+	select GROUP_IOSCHED
+	default n
+	---help---
+	  Enable hierarhical scheduling in noop. In this mode noop keeps
+	  one IO queue per cgroup instead of a global queue. Elevator
+	  fair queuing logic ensures fairness among various queues.
+
 config IOSCHED_AS
 	tristate "Anticipatory I/O scheduler"
 	default y
@@ -21,6 +45,18 @@ config IOSCHED_AS
 	  deadline I/O scheduler, it can also be slower in some cases
 	  especially some database loads.
 
+config IOSCHED_AS_HIER
+	bool "Anticipatory Hierarchical Scheduling support"
+	depends on IOSCHED_AS && CGROUPS
+	select ELV_FAIR_QUEUING
+	select GROUP_IOSCHED
+	default n
+	---help---
+	  Enable hierarhical scheduling in anticipatory. In this mode
+	  anticipatory keeps one IO queue per cgroup instead of a global
+	  queue. Elevator fair queuing logic ensures fairness among various
+	  queues.
+
 config IOSCHED_DEADLINE
 	tristate "Deadline I/O scheduler"
 	default y
@@ -31,8 +67,20 @@ config IOSCHED_DEADLINE
 	  a disk at any one time, its behaviour is almost identical to the
 	  anticipatory I/O scheduler and so is a good choice.
 
+config IOSCHED_DEADLINE_HIER
+	bool "Deadline Hierarchical Scheduling support"
+	depends on IOSCHED_DEADLINE && CGROUPS
+	select ELV_FAIR_QUEUING
+	select GROUP_IOSCHED
+	default n
+	---help---
+	  Enable hierarhical scheduling in deadline. In this mode deadline keeps
+	  one IO queue per cgroup instead of a global queue. Elevator
+	  fair queuing logic ensures fairness among various queues.
+
 config IOSCHED_CFQ
 	tristate "CFQ I/O scheduler"
+	select ELV_FAIR_QUEUING
 	default y
 	---help---
 	  The CFQ I/O scheduler tries to distribute bandwidth equally
@@ -40,6 +88,14 @@ config IOSCHED_CFQ
 	  working environment, suitable for desktop systems.
 	  This is the default I/O scheduler.
 
+config IOSCHED_CFQ_HIER
+	bool "CFQ Hierarchical Scheduling support"
+	depends on IOSCHED_CFQ && CGROUPS
+	select GROUP_IOSCHED
+	default n
+	---help---
+	  Enable hierarhical scheduling in cfq.
+
 choice
 	prompt "Default I/O scheduler"
 	default DEFAULT_CFQ
@@ -68,6 +124,30 @@ config DEFAULT_IOSCHED
 	default "cfq" if DEFAULT_CFQ
 	default "noop" if DEFAULT_NOOP
 
-endmenu
+config TRACK_ASYNC_CONTEXT
+	bool "Determine async request context from bio"
+	depends on GROUP_IOSCHED
+	select CGROUP_BLKIO
+	default n
+	---help---
+	  Normally async request is attributed to the task submitting the
+	  request. With group ioscheduling, for accurate accounting of
+	  async writes, one needs to map the request to original task/cgroup
+	  which originated the request and not the submitter of the request.
 
+	  Currently there are generic io tracking patches to provide facility
+	  to map bio to original owner. If this option is set, for async
+	  request, original owner of the bio is decided by using io tracking
+	  patches otherwise we continue to attribute the request to the
+	  submitting thread.
+
+config DEBUG_GROUP_IOSCHED
+	bool "Debug Hierarchical Scheduling support"
+	depends on CGROUPS && GROUP_IOSCHED
+	default n
+	---help---
+	  Enable some debugging hooks for hierarchical scheduling support.
+	  Currently it just outputs more information in blktrace output.
+
+endmenu
 endif
diff --git a/block/Makefile b/block/Makefile
index e9fa4dd..94bfc6e 100644
--- a/block/Makefile
+++ b/block/Makefile
@@ -15,3 +15,4 @@ obj-$(CONFIG_IOSCHED_CFQ)	+= cfq-iosched.o
 
 obj-$(CONFIG_BLOCK_COMPAT)	+= compat_ioctl.o
 obj-$(CONFIG_BLK_DEV_INTEGRITY)	+= blk-integrity.o
+obj-$(CONFIG_ELV_FAIR_QUEUING)	+= elevator-fq.o
